=== debian/changelog ===
coq (9.1.0+dfsg-2) experimental; urgency=medium

  * Update depends from why to why3 (Closes: #1117585).

 -- Julien Puydt <jpuydt@debian.org>  Wed, 29 Oct 2025 00:18:57 +0100

coq (9.1.0+dfsg-1) experimental; urgency=medium

  * New upstream release.

 -- Julien Puydt <jpuydt@debian.org>  Wed, 17 Sep 2025 06:58:08 +0200

coq (9.0.0+dfsg-1) unstable; urgency=medium

  * New upstream release.

 -- Julien Puydt <jpuydt@debian.org>  Fri, 22 Aug 2025 11:39:19 +0200
