=== debian/control ===
Source: coq
Section: math
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders:
 Benjamin Barenblat <bbaren@debian.org>,
 Julien Puydt <jpuydt@debian.org>,
 Ralf Treinen <treinen@debian.org>,
 Stéphane Glondu <glondu@debian.org>
Standards-Version: 4.7.2
Build-Depends:
 debhelper-compat (= 13),
 dh-coq,
 dh-ocaml,
 dh-python,
 ocaml-dune,
 ocaml,
 ocaml-findlib (>= 1.8.0),
 libfindlib-ocaml-dev,
 liblablgtk3-ocaml-dev,
 liblablgtksourceview3-ocaml-dev (>= 3.0~beta8),
 libnum-ocaml-dev,
 libounit-ocaml-dev,
 libzarith-ocaml-dev,
 python3,
 rsync,
 tex-common
Rules-Requires-Root: no
Homepage: http://coq.inria.fr/
Vcs-Browser: https://salsa.debian.org/ocaml-team/coq
Vcs-Git: https://salsa.debian.org/ocaml-team/coq.git

Package: coq
Architecture: any
Depends:
 libcoq-core (= ${binary:Version}),
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends},
 ocaml,
 ocaml-findlib,
 python3
Provides: coq-${F:CoqABI}
Suggests:
 rocqide | proofgeneral,
 ledit | readline-editor,
 libcoq-core-ocaml-dev,
 why3,
 coq-doc
Description: proof assistant for higher-order logic (toplevel and compiler)
 Coq is a proof assistant for higher-order logic, which allows the
 development of computer programs consistent with their formal
 specification. It is developed using Objective Caml and Camlp5.
 .
 This package provides coqtop, a command line interface to Coq.
 .
 A graphical interface for Coq is provided in the coqide package.
 Coq can also be used with ProofGeneral, which allows proofs to be
 edited using emacs and xemacs. This requires the proofgeneral
 package to be installed.

Package: rocqide
Architecture: any
Depends:
 coq (= ${binary:Version}),
 ${shlibs:Depends},
 ${misc:Depends}
Replaces: coqide
Conflicts: coqide
Description: proof assistant for higher-order logic (gtk interface)
 Rocq is a theorem prover for higher-order logic, which allows the
 development of computer programs consistent with their formal
 specification. It is developed using Objective Caml and Camlp5.
 .
 This package provides RocqIde, a graphical user interface for
 developing proofs.

Package: libcoq-core
Architecture: any
Depends: ${misc:Depends}
Recommends: coq
Provides: ${coq:Provides}
Description: proof assistant for higher-order logic (theories)
 Coq is a proof assistant for higher-order logic, which allows the
 development of computer programs consistent with their formal
 specification. It is developed using Objective Caml and Camlp5.
 .
 This package provides existing theories that new proofs can be
 based upon, including theories of arithmetic and Boolean values.

Package: libcoq-core-ocaml
Section: ocaml
Architecture: any
Depends: ${ocaml:Depends}, ${shlibs:Depends}, ${misc:Depends}
Suggests: ocaml-findlib
Provides: ${ocaml:Provides}
Description: runtime libraries for Coq
 Coq is a proof assistant for higher-order logic, which allows the
 development of computer programs consistent with their formal
 specification. It is developed using Objective Caml and Camlp5.
 .
 This package provides runtime libraries for Coq.

Package: libcoq-core-ocaml-dev
Section: ocaml
Architecture: any
Depends: ${ocaml:Depends}, ${misc:Depends}
Provides: ${ocaml:Provides}
Description: development libraries and tools for Coq
 Coq is a proof assistant for higher-order logic, which allows the
 development of computer programs consistent with their formal
 specification. It is developed using Objective Caml and Camlp5.
 .
 This package provides and libraries needed to develop OCaml-side
 extensions to Coq.
